----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:02:24 02/05/2012 
-- Design Name: 
-- Module Name:    dampfmascine - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity multipwm is
  generic (
     N : natural := 16;                 -- bit width of pwm
     P : natural := 33);                 -- PWM rows
  Port  ( takt : in  STD_LOGIC;
          pwm : in  STD_LOGIC_VECTOR (N*P-1 downto 0);
          led : out  STD_LOGIC_VECTOR (P-1 downto 0));
end multipwm;


architecture Behavioral of multipwm is
 -- single counter for all pwms
 signal ct: natural range ((2**N)-1) downto 0:=0;

 begin
   counter: process( takt )
   begin
     if( rising_edge( takt ) ) then
       ct<= ct+1;
     end if;
   end process counter;

   -- purpose: PWM-Vergleicher für eine spalte LEDs
   -- type   : combinational
   -- inputs : ct,pwm
   -- outputs: led
   cmp: process (ct,pwm)
   begin  -- process cmp
     for R in 0 to P-1 loop
       if( ct<unsigned(pwm( R*(N+1)-1 downto R*N)) ) then led(R) <= '1';
       else
         led(R)<='0';
       end if;
     end loop;  -- R
   end process cmp;
 end Behavioral;
