----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:02:24 02/05/2012 
-- Design Name: 
-- Module Name:    dampfmascine - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

 entity muxmaschine is
  generic (
    N : natural := 16;                 -- bit width of pwm
    P : natural := 33;                 -- PWM rows
    C : natural := 24);                 -- PWM columns
  Port  ( takt   : in  STD_LOGIC;
          data   : in  STD_LOGIC_VECTOR ( 7 downto 0);
          address : in STD_LOGIC_VECTOR ( 10 downto 0);  -- hackhack
          ledout  : out STD_LOGIC_VECTOR (P-1 downto 0);
          columnv: out STD_LOGIC_VECTOR (C-1 downto 0));
end muxmaschine;

architecture Behavioral of muxmaschine is

  signal coltakt: STD_LOGIC :='0';
  signal column : natural range 0 to C-1;
  signal pwmspalte : STD_LOGIC_VECTOR ( P-1 downto 0 );

begin
  inst_multipwm: entity work.multipwm(Behavioral)
    generic map (
      N => 16,
      P => 33)
    port map (
      takt => takt,
      pwm  => pwmspalte,
      led  => ledout);
  
alles: process( takt )
  begin
end process alles;
end Behavioral;
